diff a/src/hotspot/share/opto/library_call.cpp b/src/hotspot/share/opto/library_call.cpp
--- a/src/hotspot/share/opto/library_call.cpp
+++ b/src/hotspot/share/opto/library_call.cpp
@@ -750,10 +750,19 @@
     return inline_getObjectSize();
 
   case vmIntrinsics::_blackhole:
     return inline_blackhole();
 
+  case vmIntrinsics::_shipilev_magic_timestamp:
+    return inline_timestamp(false);
+  case vmIntrinsics::_shipilev_magic_timestamp_serial:
+    return inline_timestamp(true);
+  case vmIntrinsics::_shipilev_magic_sizeOf:
+    return inline_sizeOf();
+  case vmIntrinsics::_shipilev_magic_addressOf:
+    return inline_addressOf();
+
   default:
     // If you get here, it may be that someone has added a new intrinsic
     // to the list in vmIntrinsics.hpp without implementing it here.
 #ifndef PRODUCT
     if ((PrintMiscellaneous && (Verbose || WizardMode)) || PrintOpto) {
@@ -8149,17 +8158,28 @@
   Node* n = argument(0);
   set_result(n->is_Con() ? intcon(1) : intcon(0));
   return true;
 }
 
-//------------------------------- inline_getObjectSize --------------------------------------
+//------------------------------- inline_getObjectSize/sizeOf --------------------------------------
 //
 // Calculate the runtime size of the object/array.
+//
+//   long java.lang.Runtime.sizeOf(Object obj)
 //   native long sun.instrument.InstrumentationImpl.getObjectSize0(long nativeAgent, Object objectToSize);
 //
+bool LibraryCallKit::inline_sizeOf() {
+  Node* obj = argument(0);
+  return inline_sizeOf_impl(obj);
+}
+
 bool LibraryCallKit::inline_getObjectSize() {
   Node* obj = argument(3);
+  return inline_sizeOf_impl(obj);
+}
+
+bool LibraryCallKit::inline_sizeOf_impl(Node* obj) {
   Node* klass_node = load_object_klass(obj);
 
   jint  layout_con = Klass::_lh_neutral_value;
   Node* layout_val = get_layout_helper(klass_node, layout_con);
   int   layout_is_con = (layout_val == nullptr);
@@ -8291,5 +8311,23 @@
     bh->add_req(argument(i));
   }
 
   return true;
 }
+
+bool LibraryCallKit::inline_timestamp(bool serial) {
+  insert_mem_bar(Op_MemBarCPUOrder);
+  Node* node = serial ?
+          _gvn.transform(new TimestampSerialNode(control())) :
+          _gvn.transform(new TimestampNode(control()));
+  set_result(node);
+  insert_mem_bar(Op_MemBarCPUOrder);
+  return true;
+}
+
+bool LibraryCallKit::inline_addressOf() {
+  Node* obj = argument(0);
+  Node* raw_val = _gvn.transform(new CastP2XNode(NULL, obj));
+  Node* long_val = ConvX2L(raw_val);
+  set_result(long_val);
+  return true;
+}
diff a/src/hotspot/share/opto/library_call.hpp b/src/hotspot/share/opto/library_call.hpp
--- a/src/hotspot/share/opto/library_call.hpp
+++ b/src/hotspot/share/opto/library_call.hpp
@@ -361,10 +361,12 @@
   bool inline_vector_insert();
   bool inline_vector_compress_expand();
   bool inline_index_vector();
   bool inline_index_partially_in_upper_range();
 
+  bool inline_timestamp(bool serial);
+
   Node* gen_call_to_svml(int vector_api_op_id, BasicType bt, int num_elem, Node* opd1, Node* opd2);
 
   enum VectorMaskUseType {
     VecMaskUseLoad  = 1 << 0,
     VecMaskUseStore = 1 << 1,
@@ -385,7 +387,13 @@
   }
 
   bool inline_getObjectSize();
 
   bool inline_blackhole();
+
+  bool inline_sizeOf();
+  bool inline_sizeOf_impl(Node* obj);
+
+  bool inline_addressOf();
+
 };
 
diff a/src/hotspot/share/prims/nativeLookup.cpp b/src/hotspot/share/prims/nativeLookup.cpp
--- a/src/hotspot/share/prims/nativeLookup.cpp
+++ b/src/hotspot/share/prims/nativeLookup.cpp
@@ -41,10 +41,11 @@
 #include "prims/jvm_misc.hpp"
 #include "prims/jvmtiExport.hpp"
 #include "prims/nativeLookup.hpp"
 #include "prims/unsafe.hpp"
 #include "prims/scopedMemoryAccess.hpp"
+#include "prims/shipilevMagic.hpp"
 #include "runtime/arguments.hpp"
 #include "runtime/handles.inline.hpp"
 #include "runtime/interfaceSupport.inline.hpp"
 #include "runtime/javaCalls.hpp"
 #include "runtime/os.hpp"
@@ -235,10 +236,11 @@
 #endif
 #if INCLUDE_JFR
   { CC"Java_jdk_jfr_internal_JVM_registerNatives",                 nullptr, FN_PTR(jfr_register_natives)            },
 #endif
   { CC"Java_jdk_internal_misc_ScopedMemoryAccess_registerNatives", nullptr, FN_PTR(JVM_RegisterJDKInternalMiscScopedMemoryAccessMethods) },
+  { CC"Java_net_shipilev_Magic_registerNatives",                   nullptr, FN_PTR(JVM_RegisterNetShipilevMagicMethods) },
 };
 
 static address lookup_special_native(const char* jni_name) {
   int count = sizeof(lookup_special_native_methods) / sizeof(JNINativeMethod);
   for (int i = 0; i < count; i++) {
diff a/src/hotspot/share/prims/shipilevMagic.cpp b/src/hotspot/share/prims/shipilevMagic.cpp
--- /dev/null
+++ b/src/hotspot/share/prims/shipilevMagic.cpp
@@ -0,0 +1,214 @@
+/*
+ * Copyright (c) 2022, Red Hat, Inc. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+#include "precompiled.hpp"
+#include "jni.h"
+#include "jvm.h"
+#include "classfile/javaClasses.inline.hpp"
+#include "gc/shared/collectedHeap.hpp"
+#include "oops/arrayOop.hpp"
+#include "oops/instanceKlass.inline.hpp"
+#include "oops/oop.inline.hpp"
+#include "oops/oopsHierarchy.hpp"
+#include "runtime/interfaceSupport.inline.hpp"
+#include "runtime/jniHandles.inline.hpp"
+#include "runtime/os.hpp"
+#include "runtime/orderAccess.hpp"
+#include "utilities/macros.hpp"
+
+#include OS_CPU_HEADER_INLINE(os)
+
+/**
+ * Implementation of the net.shipilev.Magic
+ */
+
+JVM_ENTRY(static jlong, NetShipilevMagic_timestamp(JNIEnv *env, jclass cls)) {
+#if defined(X86) && !defined(ZERO)
+  return os::rdtsc();
+#else
+  return -1;
+#endif
+} JVM_END
+
+JVM_ENTRY(static jlong, NetShipilevMagic_timestamp_serial(JNIEnv *env, jclass cls)) {
+#if defined(X86) && !defined(ZERO)
+  // Rely on rdtscp intrinsic to make the right thing
+  // serialization-wise. In these fallback/interpreter paths,
+  // just bite the bullet and do the fence.
+  OrderAccess::fence();
+  return os::rdtsc();
+#else
+  return -1;
+#endif
+} JVM_END
+
+JVM_ENTRY(jlong, NetShipilevMagic_sizeOf(JNIEnv *env, jclass cls, jobject obj))
+  assert(obj != NULL, "object must not be NULL");
+
+  oop o = JNIHandles::resolve_non_null(obj);
+  return o->size()*HeapWordSize;
+JVM_END
+
+JVM_ENTRY(jlong, NetShipilevMagic_addressOf(JNIEnv *env, jclass cls, jobject obj))
+  assert(obj != NULL, "object must not be NULL");
+
+  oop o = JNIHandles::resolve_non_null(obj);
+  return cast_from_oop<jlong>(o);
+JVM_END
+
+JVM_ENTRY(jlong, NetShipilevMagic_fieldOffsetOf(JNIEnv *env, jclass cls, jobject field))
+  assert(field != NULL, "field must not be NULL");
+
+  oop f    = JNIHandles::resolve_non_null(field);
+  oop m    = java_lang_reflect_Field::clazz(f);
+  Klass* k = java_lang_Class::as_Klass(m);
+  int slot = java_lang_reflect_Field::slot(f);
+
+  return InstanceKlass::cast(k)->field_offset(slot);
+JVM_END
+
+JVM_ENTRY(jlong, NetShipilevMagic_fieldSizeOf(JNIEnv *env, jclass cls, jobject field))
+  assert(field != NULL, "field must not be NULL");
+
+  oop f    = JNIHandles::resolve_non_null(field);
+  oop m    = java_lang_reflect_Field::clazz(f);
+  Klass* k = java_lang_Class::as_Klass(m);
+  int slot = java_lang_reflect_Field::slot(f);
+
+  Symbol* sig = InstanceKlass::cast(k)->field_signature(slot);
+  switch (sig->char_at(0)) {
+    case JVM_SIGNATURE_CLASS    :
+    case JVM_SIGNATURE_ARRAY    : return type2aelembytes(T_OBJECT);
+    case JVM_SIGNATURE_BYTE     : return type2aelembytes(T_BYTE);
+    case JVM_SIGNATURE_CHAR     : return type2aelembytes(T_CHAR);
+    case JVM_SIGNATURE_FLOAT    : return type2aelembytes(T_FLOAT);
+    case JVM_SIGNATURE_DOUBLE   : return type2aelembytes(T_DOUBLE);
+    case JVM_SIGNATURE_INT      : return type2aelembytes(T_INT);
+    case JVM_SIGNATURE_LONG     : return type2aelembytes(T_LONG);
+    case JVM_SIGNATURE_SHORT    : return type2aelembytes(T_SHORT);
+    case JVM_SIGNATURE_BOOLEAN  : return type2aelembytes(T_BOOLEAN);
+  }
+
+  ShouldNotReachHere();
+  return 0;
+JVM_END
+
+class GetReferencedObjectsClosure : public BasicOopIterateClosure {
+private:
+  objArrayOopDesc* const _result;
+  int _count;
+public:
+  GetReferencedObjectsClosure(objArrayOopDesc* result) : _result(result), _count(0) {}
+
+  template <typename T> void do_oop_nv(T* p) {
+    oop o = HeapAccess<>::oop_load(p);
+    if (!CompressedOops::is_null(o)) {
+      _result->obj_at_put(_count++, o);
+    }
+  }
+
+  int count() { return _count; }
+
+  virtual void do_oop(oop* p)       { do_oop_nv(p); }
+  virtual void do_oop(narrowOop* p) { do_oop_nv(p); }
+
+  // Don't use the oop verification code in the oop_oop_iterate framework.
+  debug_only(virtual bool should_verify_oops() { return false; })
+};
+
+JVM_ENTRY(jint, NetShipilevMagic_getReferencedObjects(JNIEnv *env, jclass cls, jobject obj_ref, jobjectArray ref_buf_ref))
+  oop obj = JNIHandles::resolve_non_null(obj_ref);
+  objArrayOop ref_buf = objArrayOop(JNIHandles::resolve_non_null(ref_buf_ref));
+
+  assert(Universe::heap()->is_in(obj), "object should be in heap: " PTR_FORMAT, p2i(obj));
+  assert(Universe::heap()->is_in(ref_buf), "ref buf should be in heap: " PTR_FORMAT, p2i(ref_buf));
+
+  InstanceKlass* k = InstanceKlass::cast(obj->klass());
+
+  int count = 0;
+  {
+    InstanceKlass* ik = k;
+    while (ik != NULL) {
+      count += ik->nonstatic_oop_field_count();
+      ik = ik->superklass();
+    }
+  }
+
+  if (count == 0) {
+    return 0;
+  }
+
+  if (count > ref_buf->length()) {
+    return -1;
+  }
+
+  GetReferencedObjectsClosure cl(ref_buf);
+
+#ifdef _LP64
+  if (UseCompressedOops) {
+    k->oop_oop_iterate<narrowOop>(obj, &cl);
+  } else
+#endif
+  {
+    k->oop_oop_iterate<oop>(obj, &cl);
+  }
+
+  return cl.count();
+JVM_END
+
+/// JVM_RegisterUnsafeMethods
+
+#define CC (char*)  /*cast a literal from (const char*)*/
+#define FN_PTR(f) CAST_FROM_FN_PTR(void*, &f)
+
+#define LANG "Ljava/lang/"
+
+#define OBJ LANG "Object;"
+#define CLS LANG "Class;"
+#define FLD LANG "reflect/Field;"
+
+static JNINativeMethod net_shipilev_Magic_methods[] = {
+  {CC "timestamp",            CC "()J",                 FN_PTR(NetShipilevMagic_timestamp)},
+  {CC "timestampSerial",      CC "()J",                 FN_PTR(NetShipilevMagic_timestamp_serial)},
+  {CC "sizeOf0",              CC "(" OBJ ")J",          FN_PTR(NetShipilevMagic_sizeOf)},
+  {CC "addressOf0",           CC "(" OBJ ")J",          FN_PTR(NetShipilevMagic_addressOf)},
+  {CC "getReferencedObjects", CC "(" OBJ "[" OBJ ")I",  FN_PTR(NetShipilevMagic_getReferencedObjects)},
+  {CC "fieldOffsetOf0",       CC "(" FLD ")J",          FN_PTR(NetShipilevMagic_fieldOffsetOf)},
+  {CC "fieldSizeOf0",         CC "(" FLD ")J",          FN_PTR(NetShipilevMagic_fieldSizeOf)},
+};
+
+#undef LANG
+#undef OBJ
+#undef CLS
+#undef FLD
+
+#undef CC
+#undef FN_PTR
+
+JVM_ENTRY(void, JVM_RegisterNetShipilevMagicMethods(JNIEnv *env, jclass cls)) {
+  ThreadToNativeFromVM ttnfv(thread);
+
+  int ok = env->RegisterNatives(cls, net_shipilev_Magic_methods, sizeof(net_shipilev_Magic_methods)/sizeof(JNINativeMethod));
+  guarantee(ok == 0, "register net.shipilev.Magic natives");
+} JVM_END
diff a/src/hotspot/share/prims/shipilevMagic.hpp b/src/hotspot/share/prims/shipilevMagic.hpp
--- /dev/null
+++ b/src/hotspot/share/prims/shipilevMagic.hpp
@@ -0,0 +1,35 @@
+/*
+ * Copyright (c) 2016, 2019, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+
+#ifndef SHARE_PRIMS_SHIPILEV_MAGIC_HPP
+#define SHARE_PRIMS_SHIPILEV_MAGIC_HPP
+
+#include "jni.h"
+
+extern "C" {
+  void JNICALL JVM_RegisterNetShipilevMagicMethods(JNIEnv *env, jclass cls);
+}
+
+#endif // SHARE_PRIMS_SHIPILEV_MAGIC_HPP
diff a/src/hotspot/share/runtime/vmOperation.hpp b/src/hotspot/share/runtime/vmOperation.hpp
--- a/src/hotspot/share/runtime/vmOperation.hpp
+++ b/src/hotspot/share/runtime/vmOperation.hpp
@@ -96,10 +96,11 @@
   template(ShenandoahFinalMarkStartEvac)          \
   template(ShenandoahInitUpdateRefs)              \
   template(ShenandoahFinalUpdateRefs)             \
   template(ShenandoahFinalRoots)                  \
   template(ShenandoahDegeneratedGC)               \
+  template(EpsilonCollect)                        \
   template(Exit)                                  \
   template(LinuxDllLoad)                          \
   template(WhiteBoxOperation)                     \
   template(JVMCIResizeCounters)                   \
   template(ClassLoaderStatsOperation)             \
diff a/src/java.base/share/classes/module-info.java b/src/java.base/share/classes/module-info.java
--- a/src/java.base/share/classes/module-info.java
+++ b/src/java.base/share/classes/module-info.java
@@ -133,10 +133,11 @@
     exports javax.security.auth.callback;
     exports javax.security.auth.login;
     exports javax.security.auth.spi;
     exports javax.security.auth.x500;
     exports javax.security.cert;
+    exports net.shipilev;
 
 
     // additional qualified exports may be inserted at build time
     // see make/gensrc/GenModuleInfo.gmk
 
diff a/src/java.base/share/classes/net/shipilev/Magic.java b/src/java.base/share/classes/net/shipilev/Magic.java
--- /dev/null
+++ b/src/java.base/share/classes/net/shipilev/Magic.java
@@ -0,0 +1,384 @@
+/*
+ * Copyright (c) 2022, Red Hat, Inc. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.  Oracle designates this
+ * particular file as subject to the "Classpath" exception as provided
+ * by Oracle in the LICENSE file that accompanied this code.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+package net.shipilev;
+
+import java.io.*;
+import java.lang.reflect.Field;
+import java.util.function.ToLongFunction;
+import java.util.Arrays;
+import java.util.ArrayDeque;
+import java.util.List;
+import java.util.Objects;
+import java.util.Optional;
+
+import jdk.internal.vm.annotation.IntrinsicCandidate;
+import jdk.internal.vm.annotation.DontInline;
+import jdk.internal.vm.annotation.IntrinsicCandidate;
+
+public class Magic {
+
+    /*
+     * ---------------------- INTERFACE --------------------------
+     *         (If you are lazy to look into Javadoc)
+     * -----------------------------------------------------------
+     */
+
+    /**
+     * Returns the current CPU timestamp counter.
+     * <p>
+     * Maps to RDTSC on X86. No other platform is supported (yet).
+     *
+     * @return TSC value, or -1 if not supported
+     */
+    @IntrinsicCandidate
+    public static native long timestamp();
+
+    /**
+     * Same as {@link #timestamp}, but also provides instruction
+     * stream serialization. May be more expensive.
+     * <p>
+     * Maps to RDTSCP on X86. No other platform is supported (yet).
+     *
+     * @return TSC value, or -1 if not supported
+     */
+    @IntrinsicCandidate
+    public static native long timestampSerial();
+
+    /**
+     * Returns the implementation-specific estimate of the amount of storage
+     * consumed by the specified object.
+     * <p>
+     * The estimate may change during a single invocation of the JVM.
+     *
+     * @param obj object to estimate the size of
+     * @return storage size in bytes
+     * @throws NullPointerException if {@code obj} is {@code null}
+     * @since 16
+     */
+    @DontInline // Semantics: make sure the object is not scalar replaced.
+    public static long sizeOf(Object obj) {
+        Objects.requireNonNull(obj);
+        return sizeOf0(obj);
+    }
+
+    /**
+     * Returns the implementation-specific estimate of the offset of the field
+     * within the holding container.
+     * <p>
+     * For the instance fields, the offset is from the beginning of the holder
+     * object. For the static fields, the offset is from the beginning of the
+     * unspecified holder area. As such, these offsets are useful for comparing
+     * the offsets of two fields, not for any kind of absolute addressing.
+     * <p>
+     * The estimate may change during a single invocation of the JVM, for example
+     * during class redefinition.
+     *
+     * @param field field to poll
+     * @return the field offset in bytes
+     * @throws NullPointerException if {@code field} is {@code null}
+     * @since 16
+     */
+    public static long fieldOffsetOf(Field field) {
+        Objects.requireNonNull(field);
+        return fieldOffsetOf0(field);
+    }
+
+    /**
+     * Returns the implementation-specific estimate of the field slot size for
+     * the specified object field.
+     * <p>
+     * The estimate may change during a single invocation of the JVM.
+     *
+     * TODO: Split by staticness?
+     *
+     * @param field field to poll
+     * @return the field size in bytes
+     * @throws NullPointerException if {@code field} is {@code null}
+     * @since 16
+     */
+    public static long fieldSizeOf(Field field) {
+        Objects.requireNonNull(field);
+        return fieldSizeOf0(field);
+    }
+
+    /**
+     * Returns the implementation-specific estimate of the amount of storage
+     * consumed by the specified object and all objects referenced by it.
+     * <p>
+     * The estimate may change during a single invocation of the JVM. Notably,
+     * the estimate is not guaranteed to remain stable if the object references in
+     * the walked subgraph change when {@code deepSizeOf} is running.
+     *
+     * @param obj root object to start the estimate from
+     * @return storage size in bytes
+     * @throws NullPointerException if {@code obj} is {@code null}
+     * @since 16
+     */
+    public static long deepSizeOf(Object obj) {
+        return deepSizeOf0(obj, (o) -> DEEP_SIZE_OF_TRAVERSE | DEEP_SIZE_OF_SHALLOW);
+    }
+
+
+    /**
+     * Returns the implementation-specific estimate of the amount of storage
+     * consumed by the specified object and all objects referenced by it.
+     * <p>
+     * The estimate may change during a single invocation of the JVM. Notably,
+     * the estimate is not guaranteed to remain stable if the object references in
+     * the walked subgraph change when {@code deepSizeOf} is running.
+     *
+     * @param obj root object to start the estimate from
+     * @param includeCheck callback to evaluate an object's size. The callback can
+     * return a positive value as a bitmask - valid values are
+     * {@link #DEEP_SIZE_OF_SHALLOW} to consider the object's shallow sise and
+     * {@link #DEEP_SIZE_OF_TRAVERSE} to traverse ("go deeper") the object's
+     * references. A negative value means that the absolute return value is
+     * considered and the object's references are not considered.
+     * @return storage size in bytes
+     * @throws NullPointerException if {@code obj} is {@code null}
+     * @since 16
+     */
+    public static long deepSizeOf(Object obj, ToLongFunction<Object> includeCheck) {
+        return deepSizeOf0(obj, includeCheck);
+    }
+
+    /**
+     * Returns the implementation-specific representation of the memory address
+     * where the specified object resides.
+     * <p>
+     * The estimate may change during a single invocation of the JVM. Notably,
+     * in the presence of moving garbage collector, the address can change at any
+     * time, including during the call. As such, this method is only useful for
+     * low-level debugging and heap introspection in a quiescent application.
+     * <p>
+     * The JVM is also free to provide non-verbatim answers, for example, adding
+     * the random offset in order to hide the real object addresses. Because of this,
+     * this method is useful to compare the relative Object positions, or inspecting
+     * the object alignments up to some high threshold, but not for accessing the objects
+     * via the naked native address.
+     *
+     * @param obj object to get the address of
+     * @return current object address
+     * @since 16
+     */
+    @DontInline // Semantics: make sure the object is not scalar replaced.
+    public static long addressOf(Object obj) {
+        Objects.requireNonNull(obj);
+        return addressOf0(obj);
+    }
+
+    /*
+     * ---------------------- IMPLEMENTATION --------------------------
+     */
+
+    private static native void registerNatives();
+    static {
+        registerNatives();
+    }
+
+    public Magic() {
+        throw new IllegalArgumentException("NO INSTANCE MAGIC FOR YOU.");
+    }
+
+    /**
+     * Bit value for {@link #deepSizeOf(Object, ToLongFunction)}'s callback
+     * return value to continue traversal ("go deep") of the references of
+     * the object passed to the callback.
+     */
+    public static final long DEEP_SIZE_OF_TRAVERSE = 1;
+    /**
+     * Bit value for {@link #deepSizeOf(Object, ToLongFunction)}'s callback
+     * return value to consider the shallow size of the object passed to the
+     * callback.
+     */
+    public static final long DEEP_SIZE_OF_SHALLOW = 2;
+
+    private static long handleIncludeCheck(ArrayDeque<Object> q, Object o, ToLongFunction<Object> ic, long ts, long os) {
+        long t = ic.applyAsLong(o);
+        if (t > 0) {
+            if ((t & DEEP_SIZE_OF_TRAVERSE) != 0) {
+                q.push(o);
+            }
+            if ((t & DEEP_SIZE_OF_SHALLOW) != 0) {
+                ts += os;
+            }
+        } else {
+            ts -= t;
+        }
+        return ts;
+    }
+
+    @DontInline // Semantics: make sure the object is not scalar replaced.
+    private static long deepSizeOf0(Object obj, ToLongFunction<Object> includeCheck) {
+        Objects.requireNonNull(obj);
+
+        IdentityHashSet visited = new IdentityHashSet(IdentityHashSet.MINIMUM_CAPACITY);
+        ArrayDeque<Object> q = new ArrayDeque<>();
+
+        visited.add(obj);
+
+        long rootSize = sizeOf0(obj);
+        long totalSize = handleIncludeCheck(q, obj, includeCheck, 0, rootSize);
+
+        Object[] refBuf = new Object[1];
+
+        while (!q.isEmpty()) {
+            Object o = q.pop();
+            Class<?> cl = o.getClass();
+            if (cl.isArray()) {
+                // Separate array path avoids adding a lot of (potentially large) array
+                // contents on the queue. No need to handle primitive arrays too.
+
+                if (cl.getComponentType().isPrimitive()) {
+                    continue;
+                }
+
+                for (Object e : (Object[])o) {
+                    if (e != null && visited.add(e)) {
+                        long size = sizeOf0(e);
+                        totalSize = handleIncludeCheck(q, e, includeCheck, totalSize, size);
+                    }
+                }
+            } else {
+                int objs;
+                while ((objs = getReferencedObjects(o, refBuf)) < 0) {
+                    refBuf = new Object[refBuf.length * 2];
+                }
+
+                for (int c = 0; c < objs; c++) {
+                    Object e = refBuf[c];
+                    if (visited.add(e)) {
+                        long size = sizeOf0(e);
+                        totalSize = handleIncludeCheck(q, e, includeCheck, totalSize, size);
+                    }
+                }
+
+                // Null out the buffer: do not keep these objects referenced until next
+                // buffer fill, and help the VM code to avoid full SATB barriers on existing
+                // buffer elements in getReferencedObjects.
+                Arrays.fill(refBuf, 0, objs, null);
+            }
+        }
+
+        return totalSize;
+    }
+
+    /**
+     * Peels the referenced objects from the given object and puts them
+     * into the reference buffer. Never returns nulls in reference buffer.
+     * Returns the number of valid elements in the buffer. If reference bufffer
+     * is too small, returns -1.
+     *
+     * @param obj object to peel
+     * @param refBuf reference buffer
+     * @return number of valid elements in buffer, -1 if buffer is too small
+     */
+    @IntrinsicCandidate
+    private static native int getReferencedObjects(Object obj, Object[] refBuf);
+
+    private static final class IdentityHashSet {
+        private static final int MINIMUM_CAPACITY = 4;
+        private static final int MAXIMUM_CAPACITY = 1 << 29;
+
+        private Object[] table;
+        private int size;
+
+        public IdentityHashSet(int expectedMaxSize) {
+            table = new Object[capacity(expectedMaxSize)];
+        }
+
+        private static int capacity(int expectedMaxSize) {
+            return
+                (expectedMaxSize > MAXIMUM_CAPACITY / 3) ? MAXIMUM_CAPACITY :
+                (expectedMaxSize <= 2 * MINIMUM_CAPACITY / 3) ? MINIMUM_CAPACITY :
+                Integer.highestOneBit(expectedMaxSize + (expectedMaxSize << 1));
+        }
+
+        private static int nextIndex(int i, int len) {
+            return (i + 1 < len ? i + 1 : 0);
+        }
+
+        public boolean add(Object o) {
+            while (true) {
+                final Object[] tab = table;
+                final int len = tab.length;
+                int i = System.identityHashCode(o) & (len - 1);
+
+                for (Object item; (item = tab[i]) != null; i = nextIndex(i, len)) {
+                    if (item == o) {
+                        return false;
+                    }
+                }
+
+                final int s = size + 1;
+                if (s*3 > len && resize()) continue;
+
+                tab[i] = o;
+                size = s;
+                return true;
+            }
+        }
+
+        private boolean resize() {
+            Object[] oldTable = table;
+            int oldLength = oldTable.length;
+            if (oldLength == MAXIMUM_CAPACITY) {
+                throw new IllegalStateException("Capacity exhausted.");
+            }
+
+            int newLength = oldLength * 2;
+            if (newLength <= oldLength) {
+                return false;
+            }
+
+            Object[] newTable = new Object[newLength];
+            for (Object o : oldTable) {
+                if (o != null) {
+                    int i = System.identityHashCode(o) & (newLength - 1);
+                    while (newTable[i] != null) {
+                        i = nextIndex(i, newLength);
+                    }
+                    newTable[i] = o;
+                }
+            }
+            table = newTable;
+            return true;
+        }
+    }
+
+    @IntrinsicCandidate
+    private static native long sizeOf0(Object obj);
+
+    @IntrinsicCandidate
+    private static native long addressOf0(Object obj);
+
+    // Reflection-like call, is not supposed to be fast?
+    private static native long fieldOffsetOf0(Field field);
+
+    // Reflection-like call, is not supposed to be fast?
+    private static native long fieldSizeOf0(Field field);
+
+}
